import { BrowserModule } from '@angular/platform-browser';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { NgModule } from '@angular/core';
import { HttpModule } from '@angular/http';
import { FormsModule } from '@angular/forms'; // <-- NgModel lives here
import { MdInputModule, MdDialogModule } from '@angular/material';
import { ChartModule } from 'angular2-chartjs';

import { AppComponent } from './app.component';
import { ParamInputComponent } from './components/param-input/param-input.component';
import { FieldSetComponent } from './components/field-set/field-set.component';
import { ParamFieldLineComponent } from './components/param-field-line/param-field-line.component';
import { SelectFieldLineComponent } from './components/select-field-line/select-field-line.component';
import { CheckFieldLineComponent } from './components/check-field-line/check-field-line.component';
import { CondDistriComponent } from './calculators/cond_distri/conddistri.component';
import { LechaptCalmonComponent } from './calculators/lechapt-calmon/lechaptcalmon.component';
import { SectionParametreeComponent } from './calculators/section-param/section-param.component';
import { RegimeUniformeComponent } from './calculators/regime-uniforme/regime-uniforme.component';
import { CourbeRemousComponent } from './calculators/remous/remous.component';
import { AlertDialog } from './components/alert-dialog/alert-dialog.component';
import { AppErrorModule } from './error.module';
import { CalculatorResultsComponent } from './components/calculator-results/calculator-results.component';
import { SectionResultsComponent } from './components/section-results/section-results.component';
import { GenericCalculatorComponent } from './calculators/generic/calculator.component';
import { CalcCanvasComponent } from './components/canvas/canvas.component';
import { SectionCanvasComponent } from './components/section-canvas/section-canvas.component';
import { RemousResultsComponent } from './components/remous-results/remous-results.component';

@NgModule({
  imports: [
    BrowserModule,
    BrowserAnimationsModule,
    FormsModule, // <-- import the FormsModule before binding with [(ngModel)]
    MdInputModule,
    HttpModule,
    MdDialogModule,
    ChartModule,
    AppErrorModule
  ],
  declarations: [
    AppComponent,
    ParamInputComponent,
    FieldSetComponent,
    ParamFieldLineComponent, SelectFieldLineComponent, CheckFieldLineComponent,
    CondDistriComponent, LechaptCalmonComponent, SectionParametreeComponent, GenericCalculatorComponent, RegimeUniformeComponent, CourbeRemousComponent,
    AlertDialog,
    CalculatorResultsComponent, SectionResultsComponent, RemousResultsComponent,
    CalcCanvasComponent, SectionCanvasComponent
  ],
  entryComponents: [AlertDialog],
  bootstrap: [AppComponent]
})
export class AppModule { }
