import { Component, Input, Output, EventEmitter } from '@angular/core';

import { CheckField } from '../../calculators/generic/formulaire';
import { FormulaireService } from '../../services/formulaire/formulaire.service';

@Component({
    selector: 'check-field-line',
    templateUrl: "./check-field-line.html",
})
export class CheckFieldLineComponent {
    private _check: CheckField;

    private _currentValue: boolean;

    constructor(private formulaireService: FormulaireService) {
    }

    /**
    * id input attribute
    */
    private _id: string;

    @Input()
    private set id(s: string) {
        this._id = s;
        this._check = this.formulaireService.getCheckField(this._id);
    }

    private onChange(event: any) {
        this._check.setValue(event);
    }
}
