import { Component, Input, Output, EventEmitter } from '@angular/core';

import { SelectField, SelectEntry } from '../../calculators/generic/formulaire';
import { FormulaireService } from '../../services/formulaire/formulaire.service';

@Component({
    selector: 'select-field-line',
    templateUrl: "./select-field-line.html",
})
export class SelectFieldLineComponent {
    private _select: SelectField;

    private currentValue: string;

    constructor(private formulaireService: FormulaireService) {
    }

    private get entries(): SelectEntry[] {
        return this._select.entries;
    }

    /**
    * id input attribute
    */
    private _id: string;

    @Input()
    private set id(s: string) {
        this._id = s;
        this.updateSelect();
    }

    /**
     * selected value event
     */
    @Output()
    private onSelectChange = new EventEmitter<string>();

    private updateSelect() {
        this._select = this.formulaireService.getSelectField(this._id);
        if (this._select.selectedEntry != undefined)
            this.currentValue = this._select.selectedEntry.value;
    }

    private onSelect(event: any) {
        let val = event.target.value;
        this._select.setValue(val);
        this.onSelectChange.emit(val);
    }
}
