import { Injectable } from '@angular/core';
import { Http, RequestOptions, RequestOptionsArgs, Headers, Response } from '@angular/http';
import { Observable } from "rxjs/Observable";


@Injectable()
export class HttpService {
    constructor(private http: Http) { }

    private concat(s1: string, s2: string): string {
        if (s1 == undefined)
            return s2;

        if (s2 == undefined)
            return s1;

        return s1 + s2;
    }

    public httpGetRequest(protocol: string, host: string, port: number, path: string, processDataCallback: (s: string) => void): Promise<Response> {
        let resp: Observable<Response> = this.httpGetRequestResponse(protocol, host, port, path);

        resp.map(res => res.text())
            .subscribe(
            data => processDataCallback(data),
            //            err => this.logError(err),
            //            () => console.log('Random Quote Complete')
        );

        return resp.toPromise();
    }

    public httpGetRequestResponse(protocol: string, host: string, port: number, path: string): Observable<Response> {
        let url: string;
        if (protocol != undefined)
            url = protocol + "://" + host;
        else if (host != undefined)
            url = host;

        if (port != undefined)
            url = this.concat(url, ":" + String(port));

        let p = path === "/" ? "" : path;
        url = this.concat(url, "/" + p);

        let enc = encodeURI(url);

        let opts = new RequestOptions();

        let res: Observable<Response> = this.http.get(enc, opts);
        return res;
    }
}
