export interface Observer {
    update(data: any): void;
}

// class Observable<T> {
export class Observable {
    // private data: T;

    private _observers: Observer[];

    constructor() {
        this._observers = [];
    }

    public addObserver(o: Observer) {
        this._observers.push(o);
    }

    public notifyObservers(data: any) {
        for (let o of this._observers) {
            o.update(data);
        }
    }
}
